##TodoMVC - A common demo application for popular JavaScript MVC frameworks (0.25)

##Introduction

Developers these days are spoiled with choice when it comes to selecting an MVC framework for structuring and organizing JavaScript web apps. Backbone, Spine, Ember.js (SproutCore 2.0), JavaScriptMVC... the list of new and stable solutions goes on and on, but just how do you decide on which to use in a sea of so many options?

To help solve this problem, TodoMVC was created - a project which offers the same Todo application implemented using MVC concepts in most of the popular JavaScript MVC frameworks of today. Solutions look and feel the same, have a common feature set, and make it easy for you to compare the syntax and structure of different frameworks, so you can select the one you feel the most comfortable with.

####Todo apps are included for:

<ul>
<li>Backbone.js</li>
<li>Ember.js (SproutCore 2.0)</li>
<li>Spine.js</li>
<li>JavaScriptMVC</li>
<li>Sammy.js</li>
<li>YUILibrary</li>
<li>KnockoutJS (MVVM)</li>
<li>AngularJS</li>
<li>Broke.js</li>
<li>Fidel.js</li>
<li>ExtJS</li>
</ul>

A jQuery-only version of the application is also included so you can easily see how the app can be implemented with and without a structural pattern like MVC. A modularized Backbone.js example using AMD is also now available if you pull the latest version.


##Screenshots:

Preview of some of the apps included:

<img width="90%" src='http://www.blarnee.com/images/scr342342.jpg'/>

##Team

As of January 2012, I'm happy to introduce [Aaron Boushley](https://github.com/boushley) as a core committer to TodoMVC. Aaron is a JavaScript developer with a keen interest in architectural frameworks and will be helping both standardize existing examples and improve the project as we work on expansion. 

##Official site & Getting Involved

For live previews of Todo apps and more information on the project, see the official TodoMVC site here: [http://addyosmani.github.com/todomvc/](http://addyosmani.github.com/todomvc/). 

Whilst we enjoy implementing and improving existing Todo apps, we're always interested in speaking to framework authors (and users) wishing to share Todo app implementations in their framework/solution of choice. If you have an implementation you would like to show us or a patch you would like to send upstream, please feel free to send through a pull request. One of us will be happy to review them and consider them for inclusion. 

Note that due to the current number of MVC/MVVM/MV* frameworks in circulation at the moment, it's not always possible to include each one in TodoMVC, but we'll definitely discuss the merits of any framework prior to making a decision. We hope you understand :)


##Changelog 0.25
* A number of clean-ups and fixes have been made to existing examples
* Backbone + RequireJS example added
* SproutCore 2.0 example updated to Ember.js
* KnockBack (2 examples) added


##Next release

The target release timeline for TodoMVC 0.3 in mid-January 2012. This will contain standardized revisions to existing applications as well as Dojo (and other) implementations of the Todo app.